﻿using System.Diagnostics;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.DotProlog.Terms;

namespace DotPrologTest.Terms
{
    [TestClass]
    public class TermTest
    {
        [TestMethod]
        public void TestMethod1()
        {
            var atom = Atom.Add("test");
            Trace.WriteLine(atom);
        }

        [TestMethod]
        public void TestMethod2()
        {
            var integer = new PInteger(12345);
            Trace.WriteLine(integer);
        }

        [TestMethod]
        public void TestMethod3()
        {
            var variable = new Variable();
            Trace.WriteLine(variable);
        }

        [TestMethod]
        public void TestMethod4()
        {
            var compound = new Compound(Atom.Add("compound"), new Term[] { Atom.Add("argument") } );
            Trace.WriteLine(compound);
        }

        [TestMethod]
        public void TestMethod5()
        {
            var compound1 = new Compound(Atom.Add("compound"), new Term[] { Atom.Add("argument") });
            var compound2 = new Compound(Atom.Add("compound"), new Term[] { new Variable() });
            Trace.WriteLine(compound1);
            Trace.WriteLine(compound2);
            Solution unify = TermUtilities.UnifyWithoutOccursCheck(compound1, compound2);
            Trace.WriteLine(compound1);
            Trace.WriteLine(compound2);
            Trace.WriteLine(unify);
        }

        [TestMethod]
        public void TestMethod6()
        {
            Term term = new NList {"a", "b", "c"};
            Trace.WriteLine(term);
        }
    }
}
