﻿using System.Globalization;
using JetBrains.Annotations;
using OpcLabs.BaseLib.LiveBinding;
using OpcLabs.BaseLibFactory.ComponentModel;
using OpcLabs.BaseLibFactory.Components;

namespace OpcLabs.BaseLibFactory.LiveBinding
{
    static public class AbstractBindingInstances
    {
        [NotNull]
        static public AbstractBinding Instance0 => new AbstractBinding();

        [NotNull]
        static public AbstractBinding Instance1 => new AbstractBinding { ValueTarget = ValueTargetInstances.Instance1 };

        [NotNull]
        static public AbstractBinding Instance2 => new AbstractBinding
        {
            ValueTarget = ValueTargetInstances.Instance2,
            StringFormat = "testStringFormat"
        };

        [NotNull]
        static public AbstractBinding Instance3 => new AbstractBinding
        {
            ValueTarget = ValueTargetInstances.Instance3,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance1
        };

        [NotNull]
        static public AbstractBinding Instance4 => new AbstractBinding
        {
            ValueTarget = ValueTargetInstances.Instance4,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance2,
            ConverterParameter = new object()
        };

        [NotNull]
        static public AbstractBinding Instance5 => new AbstractBinding
        {
            ValueTarget = ValueTargetInstances.Instance4,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance2,
            ConverterParameter = "testConverterParameterString"
        };

        [NotNull]
        static public AbstractBinding Instance6 => new AbstractBinding
        {
            ValueTarget = ValueTargetInstances.Instance4,
            StringFormat = "testStringFormat",
            Converter = LinearConverterInstances.Instance2,
            ConverterParameter = "testConverterParameterString",
            Culture = new CultureInfo("ar-SA")
        };

        // IMPROVE: have more ConverterParameter-s
    }
}
