﻿
using System;
using JetBrains.Annotations;

namespace OpcLabs.BaseLibFactory
{
    static public class UriPartValidValues
    {
        [NotNull]
        static public string Alpha => StringInstances.Alpha;

        [NotNull]
        static public string AlphaNumeric => StringInstances.AlphaNumeric;

        [NotNull]
        static public string Control => StringInstances.Control;

        [NotNull]
        static public string Empty => String.Empty;

        [NotNull]
        static public string Over256Chars => StringInstances.Over256Chars;

        [NotNull]
        static public string Over32768Chars => StringInstances.Over32768Chars;

        // Not this one: Over65536Chars. Gives:
        // System.Reflection.TargetInvocationException: Exception has been thrown by the target of an invocation. ---> 
        // System.UriFormatException: Invalid URI: The Uri string is too long.

        [NotNull]
        static public string SingleChar => StringInstances.SingleChar;

        [NotNull]
        static public string Special => StringInstances.Special;

        [NotNull]
        static public string Whitespace => StringInstances.Whitespace;

        [NotNull]
        static public string WithNulls => StringInstances.WithNulls;

        [NotNull]
        static public string WithUnicode => StringInstances.WithUnicode;
    }
}
