﻿using System;
using JetBrains.Annotations;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpc.DataAccess;

namespace OpcLabs.EasyOpcFactory.AlarmsAndEvents
{
    static public class AEEventDataInstances
    {
        [NotNull]
        static public AEEventData ConditionInstance1 => new AEEventData
        {
            Acknowledged = true,
            AcknowledgeRequired = true,
            Active = true,
            ActiveTime = new DateTime(2013, 9, 23, 17, 36, 1, DateTimeKind.Utc),
            ActorId = "TestActor",
            AttributeValues = {{1, 111}, {2, "bbb"}, {3, true}},
            CategoryId = 44,
            ConditionName = "TestCondition",
            Cookie = 55,
            Enabled = true,
            EventType = AEEventTypes.Condition,
            Message = "TestMessage",
            QualifiedSourceName = "TestQualifiedSource",
            Quality = DAQualities.CommFailure,
            Severity = 66,
            SubconditionName = "TestSubcondition",
            Time = new DateTime(2013, 9, 23, 17, 36, 2, DateTimeKind.Utc),
        };

        [NotNull]
        static public AEEventData ConditionInstance2 => new AEEventData
        {
            Acknowledged = true,
            AcknowledgeRequired = true,
            Active = false,
            ActiveTime = DateTime.MaxValue,
            ActorId = "TestActorId",
            AttributeValues = AEAttributeValueDictionaryInstances.Instance2,
            CategoryId = 11111111,
            ConditionName = "TestConditionName",
            Cookie = 88888888,
            Enabled = true,
            EventType = AEEventTypes.Condition,
            Message = "TestMessage",
            QualifiedSourceName = "TestQualifiedSourceName",
            Quality = DAQualities.UncertainNonspecific,
            Severity = 987,
            SubconditionName = "TestSubconditionName",
            Time = DateTime.Now.ToUniversalTime()
        };

        [NotNull]
        static public AEEventData SimpleInstance => new AEEventData
        {
            Acknowledged = true,
            AcknowledgeRequired = true,
            Active = false,
            ActiveTime = DateTime.MaxValue,
            ActorId = "TestActorId",
            AttributeValues = AEAttributeValueDictionaryInstances.Instance2,
            CategoryId = 11111111,
            ConditionName = "TestConditionName",
            Cookie = 88888888,
            Enabled = true,
            EventType = AEEventTypes.Simple,
            Message = "TestMessage",
            QualifiedSourceName = "TestQualifiedSourceName",
            Quality = DAQualities.UncertainNonspecific,
            Severity = 987,
            SubconditionName = "TestSubconditionName",
            Time = DateTime.Now.ToUniversalTime()
        };
    }
}
