﻿using JetBrains.Annotations;
using OpcLabs.BaseLibFactory.IdentityModel.User;
using OpcLabs.EasyOpc.UA.Engine;

namespace OpcLabs.EasyOpcFactory.UA.Engine
{
    static public class UASmartSessionParametersInstances
    {
        [NotNull]
        static public UASmartSessionParameters Instance1 => new UASmartSessionParameters
        {
            AlwaysPreselectEndpoint = true,
            CheckBrowseResults = true,
            CloseTimeout = 1111,
            DiagnosticsMasks = UADiagnosticsMasks.OperationAdditionalInfo,
            EndpointDescriptionChecks = UAEndpointDescriptionChecksInstances.Instance1,
            EndpointSelectionPolicy = UAEndpointSelectionPolicyInstances.Instance1,
            HoldPeriod = 2222,
            KeepAliveInterval = 3333,
            KeepAliveIntervalDebug = 4444,
            LocaleId = "testLocaleId",
            RequireMatchingServerSoftwareCertificates = true,
            RequireNonEmptyServerSignature = true,
            RequireServerEndpointsMatchDiscovery = false,
            RequireTimestampsAsRequested = true,
            RequireUniqueServerNonce = false,
            RequireValidServerNonce = false,
            RetrialDelay = 5555,
            SanitizeReferenceDescriptions = true,
            ServerShutdownRetrialDelay = 6666,
            SessionTimeout = 7777,
            StatusSubscriptionSamplingInterval = 8888,
            UpdateEndpointBeforeConnect = true,
            UserIdentity = UserIdentityInstances.Instance1,
        };

        [NotNull]
        static public UASmartSessionParameters Instance2 => new UASmartSessionParameters
        {
            AllowEndpointDomainPrompt = false,
            CheckAvailableSequenceNumbers = true,
            CheckEndpointDomain = true,
            CheckNotificationMessage = true,
            CheckSessionId = true,
            RequireUniqueAuthenticationToken = true,
            RequireValidAuthenticationToken = true,
            SessionConnectTimeout = 1111,
            ShortestAllowedRevisedSessionTimeout = 2222.22d,
        };
    }
}
