﻿using OpcLabs.BaseLib.Annotations;
using OpcLabs.BaseLib.Design;
using OpcLabs.BaseLib.Forms.Design;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Design;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace OpcLabs.BaseLibFormsTestApp
{
    public partial class DateTimeTestForm : Form
    {
        public DateTimeTestForm()
        {
            InitializeComponent();
            propertyGrid1.SelectedObject = new DateTimeValues();
        }
    }

    internal class DateTimeValues
    {
        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.MonthCalendarWithTimeAndClock))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime A00_CalendarWithTimeAndClock { get; set; } = DateTime.Now;

        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.MonthCalendarWithDateTimeOnTop))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime CalendarWithDateTimeOnTop { get; set; } = DateTime.Now;

        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.MonthCalendarWithTimeOnTop))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime CalendarWithTimeOnTop { get; set; } = DateTime.Now;

        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.DateTime))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime OneLineDateTime { get; set; } = DateTime.Now;

        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.MonthCalendarWithDateTimeAndClock))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime CalendarWithDateTimeAndClock { get; set; } = DateTime.Now;

        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.DateTimeAndClock))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime DateTimeAndClock { get; set; } = DateTime.Now;

        [EditorParameter(typeof(DateTimeWithTimeEditorParameters), nameof(DateTimeWithTimeEditorParameters.Style), nameof(DateTimeWithTimeEditorStyle.MonthCalendarWithTime))]
        [Editor(typeof(DateTimeWithTimeEditor), typeof(UITypeEditor))]
        public DateTime MonthCalendarWithTime { get; set; } = DateTime.Now;

    }
}
