﻿
using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Extensions;
using OpcLabs.EasyOpc.OperationModel;
using OpcLabs.EasyOpcLiveTest.DataAccess.Environment;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    partial class EasyDAClientTestBase
    {
        protected void WriteItemValueCatalogTest_Basic(
            [NotNull] ServerDescriptor serverDescriptor,
            [NotNull] DAItemCatalogEntry itemCatalogEntry)
        {
            WriteItemValueTest_Basic(serverDescriptor, itemCatalogEntry.Element);
        }



        private void WriteItemValueTest_Basic(
            [NotNull] ServerDescriptor serverDescriptor,
            [NotNull] DAItemDescriptor itemDescriptor)
        {
            TestSection.Arrange();
            AssertUtilities.WriteLine(serverDescriptor);
            AssertUtilities.WriteLine(itemDescriptor);
            AssertUtilities.WriteLine("");

            TestEnvironment.PrecheckServer(serverDescriptor);
            EasyDAClient client = CreateClient();

            AssertUtilities.WriteLine("Reading...");
            object value;
            try
            {
                value = client.ReadItemValue(serverDescriptor, itemDescriptor);
            }
            catch (OpcException opcException)
            {
                if (!client.SupportsTechnology(OpcTechnologies.Com))
                {
                    Assert.IsInstanceOfType(opcException.InnerException, typeof(NotSupportedException));
                    return;
                }
                throw;
            }
            AssertUtilities.WriteLine($"value: {value}");

            TestSection.Act();
            AssertUtilities.WriteLine("Writing...");
            client.WriteItemValue(serverDescriptor, itemDescriptor, value);

            TestSection.Assert();

            // IMPROVE: have test where the values changes
        }
    }
}
