﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.Extensions;
using OpcLabs.EasyOpc.OperationModel;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class EasyDAClientTest_Com_NetApi : EasyDAClientTest_Com
    {

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void ReadItemTest_Com_NetApi_UnregisteredProgID()
        {
            IEasyDAClient client = CreateClient();
            try
            {
                client.ReadItem("", UnregisteredProgId, "Simulation.Constant_R4");
                Assert.Fail();
            }
            catch (OpcException opcException)
            {
                if (!client.SupportsTechnology(OpcTechnologies.Com))
                {
                    Assert.IsInstanceOfType(opcException.InnerException, typeof(NotSupportedException));
                    return;
                }
                Exception innerException = opcException.InnerException;
                Assert.IsNotNull(innerException);

                AssertBaseException(innerException,
                    -1,
                    "http://opcfoundation.org/DataAccess/",
                    "E_NETWORK_ERROR");
            }
        }



        protected override EasyDAClient CreateClient()
        {
            EasyDAClient client = base.CreateClient();
            client.InstanceParameters.EnableNativeClient = false;
            client.InstanceParameters.EnableNetApiClient = true;
            client.InstanceParameters.EnableServiceClient = false;
            return client;
        }
    }
}
