﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace;
using OpcLabs.EasyOpc.UA.AddressSpace.Standard;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpcLiveTest.Legacy.UA.Environment;
using OpcLabs.EasyOpcLiveTest.UA.Environment;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.UA.AddressSpace
{
    public class UANodeElementCollectionTest
    {
        #region Test Methods

        [TestCategory("BinarySerialization")]
        [TestCategory("Live")]
        [TestCategory("OpcUA")]
        [TestMethod]
        public void BinarySerializationTestLive()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetLive());
        }

        [TestCategory("Live")]
        [TestCategory("OpcUA")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLive()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetLive());
        }

        #endregion



        #region Private Methods

        [NotNull]
        private UANodeElementCollection CreateSerializationTargetLive()
        {
            try
            {
                return EasyUAClient.SharedInstance.Browse(
                    LegacyUATestEnvironment.OpcFoundation_SampleServer.EndpointDescriptors.OpcTcp, UAObjectIds.ObjectsFolder, UABrowseParameters.DataNodes);
            }
            catch (UAException uaException)
            {
                Assert.Inconclusive($"Could not obtain live data: {uaException}");
                // ReSharper disable once HeuristicUnreachableCode
                return null;
            }
        }

        #endregion
    }
}
