﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace.Standard;
using OpcLabs.EasyOpc.UA.Implementation;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class OpcFoundation_GlobalDiscoveryServer_Test : UAInteroperabilityWorkshopTest
    {
        //public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] {"..."};

        //public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] {"..."};

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            UAVariableIds.Server_ServerStatus_CurrentTime
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => EasyUADefinitions
            // ReSharper disable once AssignNullToNotNullAttribute
            .GetGlobalDiscoveryServerEndpointUrlStrings(EasyUADefinitions.DemoHost).Select(s => new UAEndpointDescriptor(s));

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test01_CreateSession_UaTcp_None),
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group006_SubscriptionServices_Test09_DifferentRates),
            nameof(Group009_DataChange_Test01_MonitoredItems),
            nameof(Group009_DataChange_Test05_AbsoluteDeadbandFilter),
            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256)
        });

        public override string Password => "appuser";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { UAVariableIds.Server_ServerStatus_CurrentTime };

        public override string UserName => "demo";

        //public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] {"..."};
    }
}
