﻿
using System.Diagnostics;
using System.Threading;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.UnitTestLib;

namespace OpcLabs.OpcInteroperabilityTest.UA
{
    partial class UAInteroperabilityWorkshopTest
    {
        #region Test Methods

        [TestMethod]
        public void Group114_Challenge2_Header____________________()
        {
        }

        [TestCategory("TimeDomain")]
        [TestMethod]
        public void Group114_Challenge2_Test01_LongRunningSubscription()
        {
            TestSection.Arrange();
            const int samplingInterval = 1000;
            PrecheckTestMethod();
            UAEndpointDescriptor endpointDescriptor = EndpointDescriptorCommon;

            TestSection.Act();
            using (var client = new EasyUAClient
            {
                Isolated = true,
                IsolatedParameters = {SessionParameters = {EnableStatusSubscription = !SupportsJustOneSubscription}}
            })
            {
                client.DataChangeNotification += (sender, args) =>
                {
                    Debug.WriteLine(args);
                };

                TestSection.Act();

                // ReSharper disable once AssignNullToNotNullAttribute
                int handle = client.SubscribeDataChange(endpointDescriptor, DynamicNode1, samplingInterval);
                Thread.Sleep(1 * 60*60*1000);
                client.UnsubscribeMonitoredItem(handle);

                TestSection.Assert();
            }
        }

        #endregion
    }
}
